#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

int main() {
	int fds[2];

	if (pipe(fds) == 0) {
		if (fork() == 0) {
			close(fds[0]);   /* close the read side of pipe */
			dup2(fds[1], 1); /* my stdout is now the write side of pipe */
			
			/* Replace myself with "cat /usr/share/dict/words" */
			execlp("cat", "cat", "/usr/share/dict/words", NULL);
		}
		else {
			close(fds[1]);   /* close the write side of pipe */
			dup2(fds[0], 0); /* my stdin is now the read side of pipe */

			/* Replace myself with "wc -l" */
			execlp("wc", "wc", "-l", NULL);
		}
	}
	
	return 0;
}
